#include "JBT_B1200.h"
#include "OrbiterSoundSDK40.h"

// --------------------------------------------------------------
// Create DG visual
// --------------------------------------------------------------
void JBT_B1200::clbkVisualCreated (VISHANDLE vis, int refcount)
{
	vcmesh_dev = GetDevMesh (vis, 0);
}

// --------------------------------------------------------------
// Destroy DG visual
// --------------------------------------------------------------
void JBT_B1200::clbkVisualDestroyed (VISHANDLE vis, int refcount)
{
	vcmesh_dev = NULL;
}

// --------------------------------------------------------------
// Load virtual cockpit mode
// --------------------------------------------------------------
bool JBT_B1200::clbkLoadVC (int id) {
	SURFHANDLE display = oapiGetTextureHandle(vcmesh,1);

	switch(id){
	case 0:
			oapiVCSetNeighbours(2,1,-1,-1); 
			SetCameraOffset (_V(-0.6,1.8,3.5));
			SetCameraDefaultDirection(_V(0,-0.17365,0.98481));

			//VC
			oapiVCRegisterArea(VC_DIALS,PANEL_REDRAW_ALWAYS,PANEL_MOUSE_IGNORE);
			oapiVCRegisterArea(VC_CONTROLS,PANEL_REDRAW_ALWAYS,PANEL_MOUSE_IGNORE);
			oapiVCRegisterArea(VC_TEXT, _R(13,21,498,358),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_IGNORE, PANEL_MAP_BACKGROUND,display);

			oapiVCRegisterArea(VC_PARK, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN);
			oapiVCSetAreaClickmode_Quadrilateral(VC_PARK,_V(-0.05,1.11,3.65),_V(-0.02,1.11,3.65),_V(-0.05,1.06,3.41),_V(-0.02,1.06,3.41));

			oapiVCRegisterArea(VC_GEAR, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBPRESSED);
			oapiVCSetAreaClickmode_Quadrilateral(VC_GEAR,_V(-0.2,1.11,3.8),_V(-0.07,1.11,3.8),_V(-0.2,1.11,3.55),_V(-0.07,1.11,3.55));

			oapiVCRegisterArea(VC_WARNINGLIGHT, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN);
			oapiVCSetAreaClickmode_Quadrilateral(VC_WARNINGLIGHT,_V(-0.916925,1.42634,4.08132),_V(-0.890141,1.42634,4.08132),_V(-0.916925,1.40218,4.05076),_V(-0.890141,1.40218,4.05076));

			oapiVCRegisterArea(VC_HEADLIGHT, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN);
			oapiVCSetAreaClickmode_Quadrilateral(VC_HEADLIGHT,_V(-0.916925,1.47355,4.14106),_V(-0.890141,1.47355,4.14106),_V(-0.916925,1.4494,4.11051),_V(-0.890141,1.4494,4.11051));

			oapiVCRegisterArea(VC_COMPLEX, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN);
			oapiVCSetAreaClickmode_Quadrilateral(VC_COMPLEX,_V(-0.0445655,1.35983,3.98485),_V(-0.0177821,1.35983,3.98485),_V(-0.0445655,1.34402,3.94926),_V(-0.0177821,1.34402,3.94926));

			oapiVCRegisterArea(VC_STEERMODE, PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_RBDOWN);
			oapiVCSetAreaClickmode_Spherical(VC_STEERMODE,_V(-0.133891,1.24728,3.91843),0.1);

			oapiVCRegisterArea(VC_FUEL, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_FUEL,_V(-0.0431838,1.26864,3.91248),_V(-0.0188163,1.26864,3.91248),_V(-0.0431837,1.24701,3.90126),_V(-0.0188162,1.24701,3.90126));

			oapiVCRegisterArea(VC_BUTTON1, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_BUTTON1,_V(-0.306507,1.35905,4.00576),_V(-0.283493,1.35905,4.00576),_V(-0.306507,1.34971,3.98473),_V(-0.283493,1.34971,3.98473));

			oapiVCRegisterArea(VC_BUTTON2, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_BUTTON2,_V(-0.256507,1.35905,4.00576),_V(-0.233493,1.35905,4.00576),_V(-0.256507,1.34971,3.98473),_V(-0.233493,1.34971,3.98473));

			oapiVCRegisterArea(VC_BUTTON3, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_BUTTON3,_V(-0.206507,1.35905,4.00576),_V(-0.183493,1.35905,4.00576),_V(-0.206507,1.34971,3.98473),_V(-0.183493,1.34971,3.98473 ));

			oapiVCRegisterArea(VC_BUTTON4, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_BUTTON4,_V(-0.156507,1.35905,4.00576),_V(-0.133493,1.35905,4.00576),_V(-0.156507,1.34971,3.98473),_V(-0.133493,1.34971,3.98473));

			//UMMU
			oapiVCRegisterArea(UMMU_LEFT, PANEL_REDRAW_NEVER,PANEL_MOUSE_LBPRESSED);
			oapiVCSetAreaClickmode_Quadrilateral(UMMU_LEFT,_V(-0.98,1.1,3.7),_V(-0.98,1.1,4),_V(-0.98,1.3,3.7),_V(-0.98,1.3,4));

			oapiVCRegisterArea(UMMU_RIGHT, PANEL_REDRAW_NEVER,PANEL_MOUSE_LBPRESSED);
			oapiVCSetAreaClickmode_Quadrilateral(UMMU_RIGHT,_V(0.98,1.1,3.7),_V(0.98,1.1,4),_V(0.98,1.3,3.7),_V(0.98,1.3,4));

			break;
	case 1:
			oapiVCSetNeighbours(0,3,-1,-1);
			SetCameraOffset (_V(0.6,1.8,3.5));
			SetCameraDefaultDirection(_V(0,0,1));

			//VC
			oapiVCRegisterArea(VC_DIALS,PANEL_REDRAW_ALWAYS,PANEL_MOUSE_IGNORE);
			oapiVCRegisterArea(VC_CONTROLS,PANEL_REDRAW_ALWAYS,PANEL_MOUSE_IGNORE);
			oapiVCRegisterArea(VC_TEXT, _R(13,21,498,358),PANEL_REDRAW_ALWAYS,PANEL_MOUSE_IGNORE, PANEL_MAP_BACKGROUND,display);

			oapiVCRegisterArea(VC_PARK, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN);
			oapiVCSetAreaClickmode_Quadrilateral(VC_PARK,_V(-0.05,1.11,3.65),_V(-0.02,1.11,3.65),_V(-0.05,1.06,3.41),_V(-0.02,1.06,3.41));

			oapiVCRegisterArea(VC_GEAR, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBPRESSED);
			oapiVCSetAreaClickmode_Quadrilateral(VC_GEAR,_V(-0.2,1.11,3.8),_V(-0.07,1.11,3.8),_V(-0.2,1.11,3.55),_V(-0.07,1.11,3.55));

			oapiVCRegisterArea(VC_WARNINGLIGHT, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN);
			oapiVCSetAreaClickmode_Quadrilateral(VC_WARNINGLIGHT,_V(-0.916925,1.42634,4.08132),_V(-0.890141,1.42634,4.08132),_V(-0.916925,1.40218,4.05076),_V(-0.890141,1.40218,4.05076));

			oapiVCRegisterArea(VC_HEADLIGHT, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN);
			oapiVCSetAreaClickmode_Quadrilateral(VC_HEADLIGHT,_V(-0.916925,1.47355,4.14106),_V(-0.890141,1.47355,4.14106),_V(-0.916925,1.4494,4.11051),_V(-0.890141,1.4494,4.11051));

			oapiVCRegisterArea(VC_COMPLEX, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN);
			oapiVCSetAreaClickmode_Quadrilateral(VC_COMPLEX,_V(-0.0445655,1.35983,3.98485),_V(-0.0177821,1.35983,3.98485),_V(-0.0445655,1.34402,3.94926),_V(-0.0177821,1.34402,3.94926));

			oapiVCRegisterArea(VC_STEERMODE, PANEL_REDRAW_ALWAYS,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_RBDOWN);
			oapiVCSetAreaClickmode_Spherical(VC_STEERMODE,_V(-0.133891,1.24728,3.91843),0.1);

			oapiVCRegisterArea(VC_FUEL, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_FUEL,_V(-0.0431838,1.26864,3.91248),_V(-0.0188163,1.26864,3.91248),_V(-0.0431837,1.24701,3.90126),_V(-0.0188162,1.24701,3.90126));

			oapiVCRegisterArea(VC_BUTTON1, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_BUTTON1,_V(-0.306507,1.35905,4.00576),_V(-0.283493,1.35905,4.00576),_V(-0.306507,1.34971,3.98473),_V(-0.283493,1.34971,3.98473));

			oapiVCRegisterArea(VC_BUTTON2, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_BUTTON2,_V(-0.256507,1.35905,4.00576),_V(-0.233493,1.35905,4.00576),_V(-0.256507,1.34971,3.98473),_V(-0.233493,1.34971,3.98473));

			oapiVCRegisterArea(VC_BUTTON3, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_BUTTON3,_V(-0.206507,1.35905,4.00576),_V(-0.183493,1.35905,4.00576),_V(-0.206507,1.34971,3.98473),_V(-0.183493,1.34971,3.98473 ));

			oapiVCRegisterArea(VC_BUTTON4, PANEL_REDRAW_MOUSE,PANEL_MOUSE_LBDOWN | PANEL_MOUSE_LBUP);
			oapiVCSetAreaClickmode_Quadrilateral(VC_BUTTON4,_V(-0.156507,1.35905,4.00576),_V(-0.133493,1.35905,4.00576),_V(-0.156507,1.34971,3.98473),_V(-0.133493,1.34971,3.98473));

			//UMMU
			oapiVCRegisterArea(UMMU_LEFT, PANEL_REDRAW_NEVER,PANEL_MOUSE_LBPRESSED);
			oapiVCSetAreaClickmode_Quadrilateral(UMMU_LEFT,_V(-0.98,1.1,3.7),_V(-0.98,1.1,4),_V(-0.98,1.3,3.7),_V(-0.98,1.3,4));

			oapiVCRegisterArea(UMMU_RIGHT, PANEL_REDRAW_NEVER,PANEL_MOUSE_LBPRESSED);
			oapiVCSetAreaClickmode_Quadrilateral(UMMU_RIGHT,_V(0.98,1.1,3.7),_V(0.98,1.1,4),_V(0.98,1.3,3.7),_V(0.98,1.3,4));
			 
			break;
	case 2:
			oapiVCSetNeighbours(0,0,-1,-1);
			SetCameraOffset (_V(-1.25,2.1,4.1));
			SetCameraDefaultDirection(_V(0,0,-1));
			

			break;
	case 3:
			oapiVCSetNeighbours(1,1,-1,-1);
			SetCameraOffset (_V(1.25,2.1,4.1));
			SetCameraDefaultDirection(_V(0,0,-1));


			break;


	default: return false;
	}

	return true;
}

// --------------------------------------------------------------
// Respond to virtual cockpit mouse event
// --------------------------------------------------------------
bool JBT_B1200::clbkVCMouseEvent (int id, int event, VECTOR3 &p)
{
	switch (id) {
		case VC_GEAR:
			if      (p.y < 0.12) transmission = 0;
			else if      (p.y < 0.47) transmission = -1;
			else if      (p.y < 0.85) transmission = 1;
			else transmission = 2;
			return true;
		case VC_PARK:
			parkbrake = !parkbrake;
			return true;
		case VC_WARNINGLIGHT:
			warninglights = warningLights();
			return true;
		case VC_HEADLIGHT:
			headlights = headLights();
			return true;
		case VC_COMPLEX:
			complex ^=1;
			return true;
		case VC_STEERMODE:
			if(event == PANEL_MOUSE_LBDOWN) {
				switch(GetAttitudeMode()){
					case RCS_LIN:	
							break;
					case RCS_ROT:	
							SetAttitudeMode(RCS_LIN);
							break;
					default:
							SetAttitudeMode(RCS_ROT);
				}
			} else {
				switch(GetAttitudeMode()){
					case RCS_LIN:	
							SetAttitudeMode(RCS_ROT);
							break;
					case RCS_ROT:	
							SetAttitudeMode(RCS_NONE);
							break;
							
				}
			}
			return true;

		case VC_FUEL:
			fuel = B1200_FUELMASS;
			RedrawButtons(id,event);
			return true;
		case VC_BUTTON1:
		case VC_BUTTON2:
		case VC_BUTTON3:
		case VC_BUTTON4:
			if(event == PANEL_MOUSE_LBDOWN)
				ButtonLogic(id);
			RedrawButtons(id,event);
			return true;
		case UMMU_LEFT:
			Crew.EvaCrewMember(Crew.GetCrewNameBySlotNumber(0));
			return true;
		case UMMU_RIGHT:
			Crew.SetMembersPosRotOnEVA(_V(2,1.2,3.5),_V(0,0,0));
			Crew.EvaCrewMember(Crew.GetCrewNameBySlotNumber(1));
			Crew.SetMembersPosRotOnEVA(_V(-2,1.2,3.5),_V(0,0,0));
			return true;


	}
	return false;
}


// --------------------------------------------------------------
// Respond to virtual cockpit area redraw request
// --------------------------------------------------------------
bool JBT_B1200::clbkVCRedrawEvent (int id, int event, SURFHANDLE surf)
{
	switch (id) {
		case VC_DIALS:
			RedrawSpeedo ();
			RedrawRev ();
			RedrawFuel ();
			RedrawGear ();//Above to return false
			return false;
		case VC_CONTROLS:
			RedrawSteeringWheel();
			RedrawThrottle();
			RedrawBrake();
			return false;
		case VC_TEXT:
			return RedrawText (surf);
		case VC_PARK:
			RedrawParkbrake();
			return false;
		case VC_GEAR:
			RedrawGearStick();
			return false;
		case VC_WARNINGLIGHT:	
		case VC_HEADLIGHT:		
		case VC_COMPLEX:
		case VC_STEERMODE:
			RedrawSwitches();
			return false;
	}
	return false;

}

//Display Functions

void  JBT_B1200::RedrawSpeedo(){
	double speed = fabs(currentSpeed);
	double angle = (speed != 0)?speed/8.3333333:0;
	SetAnimation(anim_Speedo,angle);
}
void  JBT_B1200::RedrawRev(){

	double angle = (engineRPM > 0)?engineRPM/2500:0;
	
	SetAnimation(anim_Rev,angle);
}
void  JBT_B1200::RedrawFuel(){

	double angle = (fuel > 0)?fuel/B1200_FUELMASS:0;
	SetAnimation(anim_Fuel,angle);
}
void  JBT_B1200::RedrawGear(){
	double pos=0.33333;
	switch(transmission){
		case -1	:	pos=0;
					break;
		case 0	:	pos=0.33333;
					break;
		case 1	:	pos=0.66666;
					break;
		case 2	:	pos=1;
					break;
	}
	
	SetAnimation(anim_Gear,pos);
}
bool JBT_B1200::RedrawText(SURFHANDLE surf){
	//337px * 485px

	oapi::Font *parmFont = oapiCreateFont (32, true, "Sans", FONT_BOLD);
	oapi::Font *startFont = oapiCreateFont (80, true, "Sans", FONT_BOLD);
	oapi::Pen *buttonPen = oapiCreatePen(1,4,0xFFFFFF);
	oapi::Sketchpad *skp = oapiGetSketchpad (surf);
	skp->SetTextColor(0xFFFFFF);

	
	if(starter){
		skp->SetFont(parmFont);
		char vesselName[32] = "";
		char text[48];
		switch (JBT_B1200::mode) {
			case -2 :	skp->Text(5,5,"Towbar Attached to: Rear",24);
						oapiGetObjectName(GetAttachmentStatus(back),vesselName,32); 

						strcpy(text,"Vessel Attached:");
						strcat(text,vesselName);
						skp->Text(5,30,text,strlen(text));
						skp->Text(45,260,"Detach Vessel | Detach Towbar",29);
						skp->Text(180,300,"Back  |  Back",13);

						break;

			case -1 :	skp->Text(5,5,"Towbar Attached to: Rear",24);
						skp->Text(37,260,"Attach Vessel to | Detach Towbar",33);
						skp->Text(180,300,"Back  |  Back",13);
						break;

			case 0 :	
						skp->Text(140,260,"Attach Towbar to",16);
						skp->Text(175,300,"Front  |  Back",14);
						break;

			case 1 :	skp->Text(5,5,"Towbar Attached to: Front",25);
						skp->Text(35,260,"Attach Vessel to | Detach Towbar",33);
						skp->Text(170,300,"Front  |  Front",15);
						break;

			case 2 :	skp->Text(5,5,"Towbar Attached to: Front",25);
						oapiGetObjectName(GetAttachmentStatus(front),vesselName,32); 
						strcpy(text,"Vessel Attached:");
						strcat(text,vesselName);
						skp->Text(5,30,text,strlen(text));
						skp->Text(50,260,"Detach Vessel | Detach Towbar",29);
						skp->Text(170,300,"Front  |  Front",15);
						break;
			}//switch
	}
	else{
		skp->SetFont(startFont);
		skp->Text(130,250,"START",5);
		skp->SetPen(buttonPen);
		skp->Line(80,335,80,240);
		skp->Line(420,335,420,240);
		skp->Line(80,240,420,240);
	}

	oapiReleaseSketchpad (skp);
	oapiReleaseFont (parmFont);
	oapiReleaseFont (startFont);
	oapiReleasePen	(buttonPen);

	return true;
}


//Control Functions
void JBT_B1200::RedrawBrake(){
	double brakeLevel = 0;
	if(!parkbrake){
		brakeLevel = GetWheelbrakeLevel(2);
	}
	SetAnimation(anim_Brake,brakeLevel);
}
void JBT_B1200::RedrawSteeringWheel(){
	double level = (GetControlSurfaceLevel(AIRCTRL_RUDDER)+1)/2;
	SetAnimation(anim_Steer,level);
}
void JBT_B1200::RedrawThrottle(){
	double level = GetThrusterGroupLevel(THGROUP_MAIN);
	SetAnimation(anim_Throttle,level);
}

void JBT_B1200::RedrawParkbrake(){
	if(parkbrake){
		SetAnimation(anim_Park,1);
	} else {
		SetAnimation(anim_Park,0);
	}
}
void JBT_B1200::RedrawGearStick(){
	switch(transmission){
		case -1:
			SetAnimation(anim_GearStick, 0.25);
			break;
		case 0:
			SetAnimation(anim_GearStick, 0);
			break;
		case 1:
			SetAnimation(anim_GearStick, 0.7);
			break;
		case 2:
			SetAnimation(anim_GearStick, 1);
			break;
	}	
}
void JBT_B1200::RedrawSwitches(){
	if(headlights){
		SetAnimation(anim_Head,1);
	} else {
		SetAnimation(anim_Head,0);
	}

	if(warninglights){
		SetAnimation(anim_Warn,1);
	} else {
		SetAnimation(anim_Warn,0);
	}

	if(complex){
		SetAnimation(anim_Complex,1);
	} else {
		SetAnimation(anim_Complex,0);
	}
	switch(GetAttitudeMode()) {
		case RCS_LIN:	
				SetAnimation(anim_SteerMode,1);
				break;
		case RCS_ROT:	
				SetAnimation(anim_SteerMode,0.5);
				break;
		default:
				SetAnimation(anim_SteerMode,0);
	}//switch
}
void JBT_B1200::RedrawButtons(int id,int event){
	double down = (event == PANEL_MOUSE_LBDOWN)?0:1;
	switch(id){
		case VC_FUEL :		
			SetAnimation(anim_FuelBtn,down);
			break;
		case VC_BUTTON1:
		case VC_BUTTON2:
		case VC_BUTTON3:
		case VC_BUTTON4:
			int i = id - 11;
			SetAnimation(anim_Button[i],down);
	}
}

//Button Functions
bool JBT_B1200::headLights(){

	SURFHANDLE surf = oapiGetTextureHandle(vcmesh,5);

	if(headlights) {
		headlight->Activate(false);
		headlights_beac[0].active = false;
		headlights_beac[1].active = false;
		illumlights_beac[0].active = false;
		illumlights_beac[1].active = false;
		
		oapiBlt(surf,surf,636,876,6,634,88,60);
		
		if(vcmesh_dev) {
			{
				COLOUR4 d = {0.8,0.0,0.0,1.0};
				COLOUR4 a = {0.8,0.0,0.0,1.0};
				COLOUR4 s = {0.823529,0.823529,0.823529,1.0};
				COLOUR4 e = {0.2,0.0,0.0,1.0};
				MATERIAL illum = {d,a,s,e,0};
				oapiSetMaterial(vcmesh_dev,0,&illum);
			}
			{
				COLOUR4 d = {1.0,1.0,1.0,1.0};
				COLOUR4 a = {1.0,1.0,1.0,1.0};
				COLOUR4 s = {1.0,1.0,1.0,1.0};
				COLOUR4 e = {0.5,0.5,0.5,0.5};
				MATERIAL illum = {d,a,s,e,0};
				oapiSetMaterial(vcmesh_dev,9,&illum); 
			}
			{
				COLOUR4 d = {1.0,1.0,1.0,1.0};
				COLOUR4 a = {1.0,1.0,1.0,1.0};
				COLOUR4 s = {1.0,1.0,1.0,1.0};
				COLOUR4 e = {0.2,0.2,0.2,0.2};
				MATERIAL illum = {d,a,s,e,0};
				oapiSetMaterial(vcmesh_dev,1,&illum); 
			}
			{
				COLOUR4 d = {0.87451,0.87451,0.87451,1.0};
				COLOUR4 a = {0.87451,0.87451,0.87451,1.0};
				COLOUR4 s = {0.9,0.9,0.9,1.0};
				COLOUR4 e = {0.2,0.2,0.2,1.0};
				MATERIAL illum = {d,a,s,e,0};
				oapiSetMaterial(vcmesh_dev,7,&illum); 
			}
		}
		
		return false;
	}
	else {
		headlight->Activate(true);
		headlights_beac[0].active = true;
		headlights_beac[1].active = true;
		illumlights_beac[0].active = true;
		illumlights_beac[1].active = true;

		oapiBlt(surf,surf,636,876,198,634,88,60);

		if(vcmesh_dev) {
			{
				COLOUR4 d = {0.470588,0.0,0.0,1.0};
				COLOUR4 a = {0.470588,0.0,0.0,1.0};
				COLOUR4 s = {0.823529,0.823529,0.823529,1.0};
				COLOUR4 e = {0.6,0.0,0.0,1.0};
				MATERIAL illum = {d,a,s,e,0};
				oapiSetMaterial(vcmesh_dev,0,&illum);
			}
			{
				COLOUR4 d = {1.0,1.0,1.0,1.0};
				COLOUR4 a = {1.0,1.0,1.0,1.0};
				COLOUR4 s = {1.0,1.0,1.0,1.0};
				COLOUR4 e = {1.0,1.0,1.0,1.0};
				MATERIAL illum = {d,a,s,e,0};
				oapiSetMaterial(vcmesh_dev,9,&illum); 
			}
			{
				COLOUR4 d = {1.0,1.0,1.0,1.0};
				COLOUR4 a = {1.0,1.0,1.0,1.0};
				COLOUR4 s = {1.0,1.0,1.0,1.0};
				COLOUR4 e = {1.0,1.0,1.0,1.0};
				MATERIAL illum = {d,a,s,e,0};
				oapiSetMaterial(vcmesh_dev,1,&illum); 
			}
			{
				COLOUR4 d = {0.87451,0.87451,0.87451,1.0};
				COLOUR4 a = {0.87451,0.87451,0.87451,1.0};
				COLOUR4 s = {0.9,0.9,0.9,1.0};
				COLOUR4 e = {0.4,0.5,0.5,1.0};
				MATERIAL illum = {d,a,s,e,0};
				oapiSetMaterial(vcmesh_dev,7,&illum); 
			}
		}

		return true;
	}
}
bool JBT_B1200::warningLights(){
	if(warninglights) {
		warninglights_beac[0].active = false;
		warninglights_beac[1].active = false;

		return false;
	}
	else {
		warninglights_beac[0].active = true;
		warninglights_beac[1].active = true;

		return true;
	}
}
bool JBT_B1200::parkLights(){
	SURFHANDLE surf = oapiGetTextureHandle(vcmesh,5);
	
	if(parklights) {
		parklights_beac[0].active = false;
		parklights_beac[1].active = false;
		oapiBlt(surf,surf,740,874,5,630,88,70);

		return false;
	}
	else {
		parklights_beac[0].active = true;
		parklights_beac[1].active = true;
		oapiBlt(surf,surf,740,874,103,630,88,70);

		return true;
	}
}
bool JBT_B1200::brakeLights(){
	if(brakelights) {
		brakelights_beac[0].active = false;
		brakelights_beac[1].active = false;

		return false;
	}
	else {
		brakelights_beac[0].active = true;
		brakelights_beac[1].active = true;

		return true;
	}
}

void JBT_B1200::ButtonLogic(int id){
	if(starter){

		switch (JBT_B1200::mode) {
			case -2 :	if(id == VC_BUTTON2){
							if(AttachPlane(false,false) && complex == 0){
								mode = -1;
								PlayVesselWave(MyID,CLANG,NOLOOP);
							}
						}
						if(id == VC_BUTTON3){
							if(AttachPlane(false,false) && complex == 0){
								mode = -1;
								PlayVesselWave(MyID,CLANG,NOLOOP);
								if(AttachTowbar(false,false)){
									mode = 0;
								}
							}
						}
						break;

			case -1 :	
						if(id == VC_BUTTON2){
							if(AttachPlane(false,true) && complex == 0){
								mode = -2;
								PlayVesselWave(MyID,CLANG,NOLOOP);
							}
						}
						if(id == VC_BUTTON3){
							if(AttachTowbar(false,false)){
								mode = 0;
								PlayVesselWave(MyID,CLANG,NOLOOP);
							}
						}
						
						break;

			case 0 :	if(id == VC_BUTTON2){	
							if(AttachTowbar(true,true)){
								mode = 1;
								PlayVesselWave(MyID,CLANG,NOLOOP);
							}
						}
						if(id == VC_BUTTON3){
							if(AttachTowbar(false,true)){
								mode = -1;
								PlayVesselWave(MyID,CLANG,NOLOOP);
							}
						}
						break;

			case 1 :	if(id == VC_BUTTON2){
							if(AttachPlane(true,true) && complex == 0){
								mode = 2;
								PlayVesselWave(MyID,CLANG,NOLOOP);
							}
						}
						if(id == VC_BUTTON3){
							if(AttachTowbar(true,false)){
								mode = 0;
								PlayVesselWave(MyID,CLANG,NOLOOP);
							}
						}

						break;

			case 2 :	if(id == VC_BUTTON2){
							if(AttachPlane(true,false) && complex == 0){
								mode = 1;
								PlayVesselWave(MyID,CLANG,NOLOOP);
							}
						}
						if(id == VC_BUTTON3){
							if(AttachPlane(true,false) && complex == 0){
								mode = 1;
								PlayVesselWave(MyID,CLANG,NOLOOP);
								if(AttachTowbar(true,false)){
									mode = 0;
								}
							}
						}
						break;
			}//switch
	}
	else{
		starter = true;
		timeIdle = 0;
		PlayVesselWave(MyID,STARTER,NOLOOP);
	}

}
// --------------------------------------------------------------
// HUD redesign
// --------------------------------------------------------------

/*bool JBT_B1200::clbkDrawHUD  ( int  mode, const HUDPAINTSPEC *  hps, oapi::Sketchpad *  skp)
{
	
	//VESSEL3::clbkDrawHUD (mode, hps, skp);
	
	//oapiSetHUDMode(HUD_NONE);
	//oapiOpenMFD(MFD_NONE,MFD_LEFT);
	//oapiOpenMFD(MFD_NONE,MFD_RIGHT);

	


	skp->SetOrigin(0,0);

	oapi::Pen* pOrgPen;

	int rightThirdCentreX = hps->W/6*5;
	int rightThirdCentreY = hps->H/2;

	
	oapi::Font* speedoFont = oapiCreateFont(30,true,"Sans",(FontStyle)(oapi::Font::BOLD));
	oapi::Font*	infoFont = oapiCreateFont(20,true,"Sans",(FontStyle)(oapi::Font::BOLD));
	//oapi::Font* indicatorFont =oapiCreateFont(50,true,"Sans",(FontStyle)(oapi::Font::BOLD));

	//Problem below here?
	oapi::Pen* needleRedPen = oapiCreatePen(1,4,0x0000CC);
	//oapi::Pen* infoPen = oapiCreatePen(1,8,0x00CCCC);
	
	
	oapi::Pen* infoPen[4];

	/*
	infoPen[0]= oapiCreatePen(1,4,0x0000CC);
	infoPen[1]= oapiCreatePen(1,4,0x0000CC);
	infoPen[2]= oapiCreatePen(1,4,0x0000CC);
	infoPen[3]= oapiCreatePen(1,4,0x0000CC);
	*/
	/*infoPen[0]= oapiCreatePen(1,4,B1200_HUDCOLOURS[0]);
	infoPen[1]= oapiCreatePen(1,4,B1200_HUDCOLOURS[1]);
	infoPen[2]= oapiCreatePen(1,4,B1200_HUDCOLOURS[2]);
	infoPen[3]= oapiCreatePen(1,4,B1200_HUDCOLOURS[3]);

	//Draw our 4 Letter inicators Lights, Strobe, Park, Gear
	int letterX = rightThirdCentreX + 100;
	int letterX1 = letterX + 50;
	
	
	

	
	int RX1 = letterX - 25;
	int RX2 = letterX1 + 10;
	int RX = (RX1+RX2)/2;
	int RDist = (RX2-RX1)/3*2;

	//oapi::Pen* rectPen = oapiCreatePen(1,RDist,0x666666);

	int RY1 = rightThirdCentreY - 150;
	int RY2 = rightThirdCentreY + 50;
	
	//--------------------------------------------
	//Indicator Lights
	//--------------------------------------------
	{
	
	skp->SetFont(speedoFont);
	skp->SetTextColor(B1200_HUDCOLOURS[HudColour]);	
	//pOrgPen = skp->SetPen(rectPen);
	//skp->Line(RX,RY1,RX,RY2);

	int letterY = rightThirdCentreY - 150;
	//int letterY1 = letterY + 50;

	

	if(indicators[0]) {
		//Headlight
		skp->Text(letterX,letterY,"H",1);
		/*skp->SetBackgroundMode(skp->BK_OPAQUE);
		skp->SetBackgroundColor(0xFF0000);
		skp->SetTextColor(0xFFFFFF);
		skp->TextBox(letterX,letterY,letterX1,letterY1,"H",1);*/
	/*	}//if Headlights
	else {
		//skp->Text(letterX,letterY,"H",4);
		/*skp->SetBackgroundMode(skp->BK_OPAQUE);
		skp->SetBackgroundColor(0x000000);
		skp->SetTextColor(0xFF0000;)
		skp->TextBox(letterX,letterY,letterX1,letterY1,"H",1);*/
	/*}//else Headlights

	letterY = rightThirdCentreY - 100;
	//letterY1 = letterY + 50;

	if(indicators[1]) {
		//Warning / Flash
		skp->Text(letterX,letterY,"W",1);
		/*skp->SetBackgroundMode(skp->BK_OPAQUE);
		skp->SetBackgroundColor(0x0066FF);
		skp->SetTextColor(0xFFFFFF);
		skp->TextBox(letterX,letterY,letterX1,letterY1,"F",1);*/
	/*	}//if Warning / Flash
	else {
		/*skp->SetBackgroundMode(skp->BK_OPAQUE);
		skp->SetBackgroundColor(0x000000);
		skp->SetTextColor(0x0066FF);
		skp->TextBox(letterX,letterY,letterX1,letterY1,"F",1);*/
	/*}//else Warning / Flash

	letterY = rightThirdCentreY - 50;
	//letterY1 = letterY + 50;

	if(indicators[2]) {
		//Park Brake
		skp->Text(letterX,letterY,"P",1);
		/*skp->SetBackgroundMode(skp->BK_OPAQUE);
		skp->SetBackgroundColor(0x0000FF);
		skp->SetTextColor(0xFFFFFF);
		skp->TextBox(letterX,letterY,letterX1,letterY1,"P",1);*/
	/*	}//if Park Brake
	else {
		/*skp->SetBackgroundMode(skp->BK_OPAQUE);
		skp->SetBackgroundColor(0x000000);
		skp->SetTextColor(0x0000FF);
		skp->TextBox(letterX,letterY,letterX1,letterY1,"P",1);*/
	/*}//else Park Brake

	letterY = rightThirdCentreY + 0;
	//letterY1 = letterY + 50;

	//skp->SetBackgroundMode(skp->BK_TRANSPARENT);
	//skp->SetBackgroundColor(0x000000);
	//skp->SetTextColor(0x00FF00);
	switch (transmission) {
		case 2: //skp->TextBox(letterX,letterY,letterX1,letterY1,"L",1);
				skp->Text(letterX,letterY,"L",1);
				break;
		case 1: //skp->TextBox(letterX,letterY,letterX1,letterY1,"D",1);
				skp->Text(letterX,letterY,"D",1);
				break;
		case 0: //skp->TextBox(letterX,letterY,letterX1,letterY1,"N",1);
				skp->Text(letterX,letterY,"N",1);
				break;
		case -1: //skp->TextBox(letterX,letterY,letterX1,letterY1,"R",1);
				skp->Text(letterX,letterY,"R",1);
				break;
	}//switch
	
	letterY = rightThirdCentreY + 50;
	//letterY1 = letterY + 50;

	//skp->SetBackgroundMode(skp->BK_TRANSPARENT);
	//skp->SetBackgroundColor(0x000000);
	//skp->SetTextColor(0x00FF00);
	switch (steerMode) {
		case 2: //skp->TextBox(letterX,letterY,letterX1,letterY1,"L",1);
				skp->Text(letterX,letterY,"C",1);
				break;
		case 1: //skp->TextBox(letterX,letterY,letterX1,letterY1,"D",1);
				skp->Text(letterX,letterY,"4",1);
				break;
		case 0: //skp->TextBox(letterX,letterY,letterX1,letterY1,"N",1);
				skp->Text(letterX,letterY,"2",1);
				break;
	}//switch

	}//Indicator
	
	

	//--------------------------------------------
	//Speedo
	//--------------------------------------------
	{
	//Set the pen to draw the arc
	
	pOrgPen =	skp->SetPen(infoPen[HudColour]);
	//Set centre
	int dialX = rightThirdCentreX, dialY = rightThirdCentreY;
	
	//Set intial conditions
	double radius, angle1, angle2;
	radius = 200;
	angle1 = 195 * RAD;
	angle2 = 75 * RAD;
	int x1 = 0,y1 = 0,x2 = 0,y2 = 0;
	
	//Run through the arc and draw it
	for(double i = angle1; i > angle2; i -= 0.01){
		x1 = (int)(-sin(i)*radius + 0.5 + dialX);
		y1 = (int)(cos(i)*radius + 0.5 + dialY);
		skp->Line(x1,y1,x1,y1);
	}//for
	
	//Interval Markings
	//Here No. is 6 with 5 spaces
	double interval = (angle1 - angle2)/5;
	double angle;
	
	//For the Text display
	int x3,y3;
	char* speedo[6] = {"25","20","15","10","5","0"};
	skp->SetTextAlign(skp->CENTER,skp->TOP);
	
	//Set font for Text
	skp->SetFont(speedoFont);
	skp->SetTextColor(B1200_HUDCOLOURS[HudColour]);

	//Draw text and markers at correct spots
	for(int i = 0; i <= 5; i++){
		angle = angle1 - interval*i;
		x1 = (int)(-sin(angle)*radius + 0.5 + dialX);
		y1 = (int)(cos(angle)*radius + 0.5 + dialY);
		x2 = (int)(-sin(angle)*radius*0.9 + 0.5 + dialX);
		y2 = (int)(cos(angle)*radius*0.9 + 0.5 + dialY);
		x3 = (int)(-sin(angle)*radius*0.8 + 0.5 + dialX);
		y3 = (int)(cos(angle)*radius*0.8 + 0.5 + dialY);
		skp->Text(x3,y3,speedo[i],2);
		skp->Line(x1,y1,x2,y2);
	}//for
	
	//Draw Title
	x3 = (int)(-sin(PI/4*3)*radius*0.4 + 0.5 + dialX);
	y3 = (int)(cos(PI/4*3)*radius*0.4 + 0.5 + dialY);
	skp->Text(x3,y3,"Km/h",4);
	skp->SetTextAlign(skp->LEFT,skp->TOP);

	//Set pen for Needle
	skp->SetPen(needleRedPen);
	
	//Calculate deflection of needle
	double speedRatio = 0;
	//if (currentSpeed > 0)
		speedRatio = (fabs(currentSpeed)/B1200_MAXSPEED);

	angle = (angle1 - angle2)*speedRatio + angle2;
	
	//Draw needle
	x1 = (int)(-sin(angle)*radius*0.95 + 0.5 + dialX);
	y1 = (int)(cos(angle)*radius*0.95 + 0.5 + dialY);
	skp->Line(x1,y1,dialX,dialY);

	}//Speedo

	//--------------------------------------------
	//Rev Counter
	//--------------------------------------------
	{
	//Set the pen to draw the arc

	skp->SetPen(infoPen[HudColour]);
	
	//Set centre
	int dialX = rightThirdCentreX - 160, dialY = rightThirdCentreY + 200;
	
	//Set intial conditions
	double radius, angle1, angle2;
	radius = 100;
	angle1 = 135 * RAD;
	angle2 = 240 * RAD;
	int x1 = 0,y1 = 0,x2 = 0,y2 = 0;
	
	//Interval Markings
	//Here No. is 6 with 5 spaces
	double interval = (angle1 - angle2)/5;
	double angle;
	
	//For the Text display
	int x3,y3;
	char* rev[6] = {"0","5","10","15","20","25"};
	skp->SetTextAlign(skp->CENTER,skp->TOP);
	
	//Set font for Text
	skp->SetFont(infoFont);
	skp->SetTextColor(B1200_HUDCOLOURS[HudColour]);

	//Draw text and markers at correct spots
	for(int i = 0; i <= 5; i++){
		angle = angle1 - interval*i;
		x1 = (int)(-sin(angle)*radius + 0.5 + dialX);
		y1 = (int)(cos(angle)*radius + 0.5 + dialY);
		x2 = (int)(-sin(angle)*radius*0.9 + 0.5 + dialX);
		y2 = (int)(cos(angle)*radius*0.9 + 0.5 + dialY);
		x3 = (int)(-sin(angle)*radius*0.8 + 0.5 + dialX);
		y3 = (int)(cos(angle)*radius*0.8 + 0.5 + dialY);
		skp->Text(x3,y3,rev[i],2);
		skp->Line(x1,y1,x2,y2);
	}//for
	
	//Draw Title
	x3 = (int)(-sin(PI)*radius*0.4 + 0.5 + dialX);
	y3 = (int)(cos(PI)*radius*0.4 + 0.5 + dialY);
	skp->Text(x3,y3,"x100 RPM",8);
	skp->SetTextAlign(skp->LEFT,skp->TOP);

	//Set pen for Needle
	skp->SetPen(needleRedPen);
	
	//Calculate deflection of needle
	angle = (angle2 - angle1)*(engineRPM/2500) + angle1;
	
	//Draw needle
	x1 = (int)(-sin(angle)*radius*0.95 + 0.5 + dialX);
	y1 = (int)(cos(angle)*radius*0.95 + 0.5 + dialY);
	skp->Line(x1,y1,dialX,dialY);

	}

	//--------------------------------------------
	//Steering Indicator
	//--------------------------------------------
	{
	//Set the pen to draw the arc
	skp->SetPen(infoPen[HudColour]);
	
	//Set centre
	int dialX = rightThirdCentreX, dialY = rightThirdCentreY + 200;
	
	//Set intial conditions
	double radius, angle1, angle2;
	radius = 100;
	angle1 = 135 * RAD;
	angle2 = 225 * RAD;
	int x1 = 0,y1 = 0,x2 = 0,y2 = 0;
	
	//Interval Markings
	//Here No. is 5 with 4 spaces
	double interval = (angle1 - angle2)/4;
	double angle;
	
	//For the Text display
	int x3,y3;
	char* rev[5] = {"20","10","0","10","20"};
	skp->SetTextAlign(skp->CENTER,skp->TOP);
	
	//Set font for Text
	skp->SetFont(infoFont);
	skp->SetTextColor(B1200_HUDCOLOURS[HudColour]);

	//Draw text and markers at correct spots
	for(int i = 0; i <= 4; i++){
		angle = angle1 - interval*i;
		x1 = (int)(-sin(angle)*radius + 0.5 + dialX);
		y1 = (int)(cos(angle)*radius + 0.5 + dialY);
		x2 = (int)(-sin(angle)*radius*0.9 + 0.5 + dialX);
		y2 = (int)(cos(angle)*radius*0.9 + 0.5 + dialY);
		x3 = (int)(-sin(angle)*radius*0.8 + 0.5 + dialX);
		y3 = (int)(cos(angle)*radius*0.8 + 0.5 + dialY);
		skp->Text(x3,y3,rev[i],2);
		skp->Line(x1,y1,x2,y2);
	}//for
	
	//Draw Title
	x3 = (int)(-sin(PI)*radius*0.4 + 0.5 + dialX);
	y3 = (int)(cos(PI)*radius*0.4 + 0.5 + dialY);
	skp->Text(x3,y3,"Degrees",7);
	skp->SetTextAlign(skp->LEFT,skp->TOP);

	//Set pen for Needle
	skp->SetPen(needleRedPen);
	
	//Calculate deflection of needle
	angle = -(angle1 - angle2)*GetControlSurfaceLevel(AIRCTRL_RUDDER)/2 + PI;
	
	//Draw needle
	x1 = (int)(-sin(angle)*radius*0.95 + 0.5 + dialX);
	y1 = (int)(cos(angle)*radius*0.95 + 0.5 + dialY);
	skp->Line(x1,y1,dialX,dialY);


	}
	//--------------------------------------------
	//Fuel Level
	//--------------------------------------------
	{
	//Set the pen to draw the arc
	skp->SetPen(infoPen[HudColour]);
	//skp->SetPen(infoPen);
	//Set centre
	int dialX = rightThirdCentreX + 160, dialY = rightThirdCentreY + 200;
	
	//Set intial conditions
	double radius, angle1, angle2;
	radius = 100;
	angle1 = 135 * RAD;
	angle2 = 225 * RAD;
	int x1 = 0,y1 = 0,x2 = 0,y2 = 0;
	
	//Interval Markings
	//Here No. is 5 with 4 spaces
	double interval = (angle1 - angle2)/4;
	double angle;
	
	//For the Text display
	int x3,y3;
	char* rev[5] = {"E"," "," "," ","F"};
	skp->SetTextAlign(skp->CENTER,skp->TOP);
	
	//Set font for Text
	skp->SetFont(infoFont);
	skp->SetTextColor(B1200_HUDCOLOURS[HudColour]);

	//Draw text and markers at correct spots
	for(int i = 0; i <= 4; i++){
		angle = angle1 - interval*i;
		x1 = (int)(-sin(angle)*radius + 0.5 + dialX);
		y1 = (int)(cos(angle)*radius + 0.5 + dialY);
		x2 = (int)(-sin(angle)*radius*0.9 + 0.5 + dialX);
		y2 = (int)(cos(angle)*radius*0.9 + 0.5 + dialY);
		x3 = (int)(-sin(angle)*radius*0.8 + 0.5 + dialX);
		y3 = (int)(cos(angle)*radius*0.8 + 0.5 + dialY);
		skp->Text(x3,y3,rev[i],2);
		skp->Line(x1,y1,x2,y2);
	}//for
	
	//Draw Title
	x3 = (int)(-sin(PI)*radius*0.4 + 0.5 + dialX);
	y3 = (int)(cos(PI)*radius*0.4 + 0.5 + dialY);
	skp->Text(x3,y3,"Fuel",4);
	skp->SetTextAlign(skp->LEFT,skp->TOP);

	//Set pen for Needle
	skp->SetPen(needleRedPen);
	
	//Calculate deflection of needle
	angle = (angle2 - angle1)*fuel/B1200_FUELMASS + angle1;
	
	//Draw needle
	x1 = (int)(-sin(angle)*radius*0.95 + 0.5 + dialX);
	y1 = (int)(cos(angle)*radius*0.95 + 0.5 + dialY);
	skp->Line(x1,y1,dialX,dialY);

	}

	//--------------------------------------------
	//Attachment Text
	//--------------------------------------------
	{
	int leftThirdCentreX = hps->W/6;
	int leftThirdCentreY = hps->H/2 - 60;
	int lineoffset = 30;

	skp->SetFont(infoFont);
	skp->SetTextAlign(skp->LEFT,skp->TOP);
	
	int x = leftThirdCentreX, y = leftThirdCentreY;
	skp->Text(x,y,"Vessel Attached:",16);
	
	y = leftThirdCentreY + 2 * lineoffset;
	skp->Text(x,y,"Towbar Attached to:",16);
	
	char vesselName[32];

	switch (JBT_B1200::mode) {
		case -2 :	y = leftThirdCentreY + lineoffset;
					
					oapiGetObjectName(GetAttachmentStatus(back),vesselName,32); 
					skp->Text(x,y,vesselName,32);
					y = leftThirdCentreY + 3*lineoffset;
					skp->Text(x,y,"Rear",4);
					break;

		case -1 :	y = leftThirdCentreY + lineoffset;
					skp->Text(x,y,"None",4);
					y = leftThirdCentreY + 3*lineoffset;
					skp->Text(x,y,"Rear",4);
					break;

		case 0 :	y = leftThirdCentreY + lineoffset;
					skp->Text(x,y,"None",4);
					y = leftThirdCentreY + 3*lineoffset;
					skp->Text(x,y,"None",4);
					break;

		case 1 :	y = leftThirdCentreY + lineoffset;
					skp->Text(x,y,"None",4);
					y = leftThirdCentreY + 3*lineoffset;
					skp->Text(x,y,"Front",5);
					break;

		case 2 :	y = leftThirdCentreY + lineoffset;
					oapiGetObjectName(GetAttachmentStatus(front),vesselName,32); 
					skp->Text(x,y,vesselName,32);
					y = leftThirdCentreY + 3*lineoffset;
					skp->Text(x,y,"Front",5);
					break;
		}//switch

	}//AttachmentInfo
	
	// UMmu display messages
	if(dHudMessageDelay>0)
	{
		skp->Text(5,hps->H/60*15,cUmmuHudDisplay,strlen(cUmmuHudDisplay));
		dHudMessageDelay-=oapiGetSimStep();
		if(dHudMessageDelay<0)
			dHudMessageDelay=0;
	}

	skp->SetPen(pOrgPen);

	//Cleanup
	oapiReleaseFont(infoFont);
	oapiReleaseFont(speedoFont);
	//oapiReleaseFont(indicatorFont);//Remove our previously created font

	oapiReleasePen(needleRedPen);
	//oapiReleasePen(rectPen);//Remove our Pen
	
	//oapiReleasePen(infoPen);
	oapiReleasePen(infoPen[0]);
	oapiReleasePen(infoPen[1]);
	oapiReleasePen(infoPen[2]);
	oapiReleasePen(infoPen[3]);
	

	
	

	return true;
}*/

////////////////////////////////////////////////////////
// SendHudMessage                             
////////////////////////////////////////////////////////
char *JBT_B1200::SendHudMessage()   
{                                                           
              dHudMessageDelay=15;         
              return cUmmuHudDisplay;   
}                               


